//audio
datablock AudioProfile(bfgFireSound)
{
   filename    = "./bfgFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bfgChargeSound)
{
   filename    = "./bfgCharge.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bfgSteamSound)
{
   filename    = "./bfgSteam.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bfgHitSound)
{
   filename    = "./bfgHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bfgLoopSound)
{
   filename    = "./bfgLoop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(bfgChargeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 20;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 1 0 1";
	colors[1]     = "0 0.3 0 1";
	colors[2]     = "0.5 1 0.5 1";
	sizes[0]      = 1.2;
	sizes[1]      = 0.3;
	sizes[2]      = 0.5;
	times[0] = 0.0;
	times[1] = 0.4;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(bfgChargeEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = -23.0;
	velocityVariance = 0;
	ejectionOffset   = 0.6;
	thetaMin         = 0;
	thetaMax         = 1;
	phiReferenceVel  = 0;
	phiVariance      = 2;
	overrideAdvance = false;
	particles = "bfgChargeParticle";
	uiName = "bfgCharge";
};

datablock ParticleData(bfgSteamParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.7 0.7 1";
	colors[1]     = "0.5 0.5 0.5 0.6";
	colors[2]     = "0.5 .5 0.5 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.15;
	sizes[2]      = 0.05;
	times[0] = 0.0;
	times[1] = 0.2;
	times[2] = 0.4;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(bfgSteamEmitter)
{
	ejectionPeriodMS = 4;
	periodVarianceMS = 1;
	ejectionVelocity = 20.0;
	velocityVariance = 1.0;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 0;
	phiReferenceVel  = 0;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "bfgSteamParticle";
	uiName = "bfgSteam";
};

datablock ParticleData(bfgFlashParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 1 0.5 1";
	colors[1]     = "0 1 0 0 1";
	colors[2]     = "0 .5 0 0";
	sizes[0]      = 2;
	sizes[1]      = 1;
	sizes[2]      = 0.5;
	times[0] = 0.0;
	times[1] = 0.2;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(bfgFlashEmitter)
{
	ejectionPeriodMS = 4;
	periodVarianceMS = 1;
	ejectionVelocity = 20.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 360000;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "bfgFlashParticle";
	uiName = "bfgFlash";
};


datablock ParticleEmitterData(bfgFlashEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 100.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 360000;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "bfgFlashParticle";
	uiName = "bfgFlash2";
};

datablock ParticleData(bfgSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.8;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0 0.5 0 0.0";
	sizes[0]      = 0.20;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(bfgSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "bfgSmokeParticle";

   uiName = "bfg Smoke";
};

AddDamageType("bfgShellDirect",   '<bitmap:add-ons/Weapon_bfg/ci_bfg> %1',    '%2 <bitmap:add-ons/Weapon_bfg/ci_bfg> %1',1,1);
AddDamageType("bfgShellRadius",   '<bitmap:add-ons/Weapon_bfg/ci_bfg> %1',    '%2 <bitmap:add-ons/Weapon_bfg/ci_bfg> %1',1,0);

datablock ParticleData(bfgParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/nut";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0 .8 0 1";
	colors[1]     = "0 .4 0 1";
	colors[2]     = "0.5 1 0.5 0";
	sizes[0]      = 2;
	sizes[1]      = 1;
	sizes[2]      = 0.5;
	times[0] = 0.0;
	times[1] = 0.25;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(bfgEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 20;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89.999999;
	thetaMax         = 90;
	phiReferenceVel  = 17600000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "bfgParticle";
	useEmitterColors = false;
	uiName = "bfgEmitter";
};

datablock ParticleEmitterData(bfgExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 6.5;
	velocityVariance = 0;
	ejectionOffset   = 8.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 60000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "bfgParticle";
	useEmitterColors = false;
	//uiName = "bfgExplosion";
};

datablock ExplosionData(bfgShellExplosion)
{
	lifeTimeMS = 750;
	particleEmitter = bfgExplosionEmitter;
	particleDensity = 10;
	particleRadius = 7;
	emitter[0] = bfgEmitter;
	//soundProfile = bfgExplosionSound;
	faceViewer     = true;
	explosionScale = "1 1 1";
	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "0 0 0 0";
	lightEndColor = "0 0 0 0";
	damageRadius = 9;
	radiusDamage = 95;
   impulseRadius = 0;
   impulseForce = 0;
};

datablock ProjectileData(bfgShellProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 0;
	directDamageType = $DamageType::bfgShellDirect;
	radiusDamageType = $DamageType::bfgShellRadius;
	impactImpulse	   = 10;
	verticalImpulse	   = 10;
	explosion           = bfgShellExplosion;
	particleEmitter	   = bfgEmitter;
//	sound = bfgLoopSound;
	muzzleVelocity      = 50;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 30000;
	fadeDelay           = 0;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 1;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 5.0;
	lightColor  = "0.2 0.8 0.2";
	uiName = "";
};

datablock ParticleData(bfgParticle2)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0.5 1 0.5 1";
	colors[1]     = "0.5 1 .5 1";
	colors[2]     = "0 1 0 0";
	sizes[0]      = 3;
	sizes[1]      = 2;
	sizes[2]      = 1;
	times[0] = 0.0;
	times[1] = 0.25;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleData(bfgParticle3)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0.5 1 0.5 1";
	colors[1]     = "0.5 1 .5 1";
	colors[2]     = "0 .5 0 0";
	sizes[0]      = 4;
	sizes[1]      = 1;
	sizes[2]      = 5;
	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 1;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(bfgEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  
	overrideAdvance = false;
	particles = "bfgParticle2";
	useEmitterColors = false;
	uiName = "bfgEmitter2";
};

datablock ParticleEmitterData(bfgExplosionEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 50;
	velocityVariance = 0.5;
	ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 1;
	overrideAdvance = false;
	particles = "bfgParticle3";
	useEmitterColors = false;
	uiName = "bfgExplosion2";
};

datablock ExplosionData(bfgShellExplosion2)
{
	explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = bfgHitSound;
	lifeTimeMS = 1000;
	particleEmitter = bfgExplosionEmitter;
	particleDensity = 100;
	particleRadius = 4;
	emitter[0] = bfgExplosionEmitter2;
	emitter[1] = bfgFlashEmitter2;
	faceViewer     = true;
	shakeCamera = true;
	camShakeFreq = "130.0 132.0 130.0";
	camShakeAmp = "52.0 52.0 52.0";
	camShakeDuration = 2.0;
	camShakeRadius = 26.0;
	explosionScale = "1 1 1";
	lightStartRadius = 40;
	lightEndRadius = 15;
	lightStartColor = "0 1 0 1";
	lightEndColor = "0 0.0 0.0 1";
	damageRadius = 16;
   radiusDamage = 50;
	impulseRadius = 22;
   impulseForce = 2000;
};

datablock ProjectileData(bfgShellProjectile2)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 500;
	directDamageType = $DamageType::bfgShellDirect;
	radiusDamageType = $DamageType::bfgShellRadius;
   brickExplosionRadius = 6;
   brickExplosionImpact = true;     
   brickExplosionForce  = 100;             
   brickExplosionMaxVolume = 300;         
   brickExplosionMaxVolumeFloating = 600; 
	impactImpulse	   = 1000;
	verticalImpulse	   = 1000;
	explosion           = bfgShellExplosion2;
	particleEmitter	   = bfgEmitter2;
	sound = bfgLoopSound;
	muzzleVelocity      = 50;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 30000;
	fadeDelay           = 0;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 1;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 20.0;
	lightColor  = "0 1 0 1";
	uiName = "bfg Shell";
};

datablock ExplosionData(bfgRecoilExplosion)
{
	explosionShape = "";
	lifeTimeMS = 150;
	faceViewer = true;
	explosionScale = "1 1 1";
	shakeCamera = true;
	camShakeFreq = "3 3 3";
	camShakeAmp = "0.3 0.5 0.4";
	camShakeDuration = 0.45;
	camShakeRadius = 10.0;
	lightStartRadius = 2;
	lightEndRadius = 4;
	lightStartColor = "0 1 0 1";
	lightEndColor = "0 0.0 0.0 1";
};

datablock ProjectileData(bfgRecoilProjectile)
{
    lifetime = 10;
    fadeDelay = 10;
    explodeondeath = true;
    explosion = bfgRecoilExplosion;
};


//////////
// item //
//////////
datablock ItemData(bfgItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	uiName = "BFG";
	
	 // Basic Item Properties
	shapeFile = "./bfg.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	//uiName = "BFG";
	iconName = "./icon_bfg";
	doColorShift = false;
	//colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = bfgImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(bfgImage)
{
   // Basic Item properties
   shapeFile = "./bfg.dts";
   emap = true;
	
   
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.0445 0 0";
   eyeOffset = "0.56 0.5 -0.8";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = bfgProjectile;
   projectileType = Projectile;

	//casing = bfgShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
	minShotTime = 3000;
   
   doColorShift = false;
   //colorShiftColor = bfgItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Steam";
	stateSound[0]					= weaponSwitchSound;
	stateScript[0]					= "OnEquip";
	
	stateName[1]					= "Steam";
	stateEmitter[1]					= bfgSteamEmitter;
	stateAllowImageChange[2]         = true;
	stateEmitterNode[1]				= "vent1";
	stateEmitterTime[1]				= 0.3;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1]		= "Ready";
	
	stateName[2]                     = "Ready";
	stateTransitionOnTriggerDown[2]  = "Charge";
	stateAllowImageChange[2]         = true;
	stateSequence[2]				= "Ready";
	stateEmitter[2]					= bfgSteamEmitter;
	stateSound[2]					= bfgSteamSound;
	stateEmitterNode[2]				= "vent2";
	stateEmittertime[2]				= 0.3;
	
	stateName[3]					= "Charge";
	stateSound[3]					= bfgChargeSound;
	stateWaitForTimeout[3]			= true;
	stateAllowImageChange[3]         = false;
	stateEmitter[3]					= bfgChargeEmitter;
	stateEmitterTime[3]				= 2.6;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]			= 2.6;
	stateTransitionOnTimeout[3]		= "Fire";
	
	
	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Smoke";
	stateTimeoutValue[4]            = 0.14;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= bfgFlashEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= bfgFireSound;
	stateEjectShell[4]       = true;

	stateName[5]					= "Smoke";
	stateEmitter[5]					= bfgSmokeEmitter;
	stateEmitterTime[5]				= 3;
	stateEmitterNode[5]				= "muzzleNode";
	stateTimeoutValue[5]            = 3;
	stateAllowImageChange[5]        = true;
	stateTransitionOnTimeout[5]     = "Reload";

	stateName[6]					= "Reload";
	stateSequence[6]                = "Reload";
	stateScript[6]					= "onReload";
	stateTransitionOnTriggerUp[6]   = "Steam";
};

datablock ShapeBaseImageData(bfgCooldwnImage)
{
   // Basic Item properties
   shapeFile = "./bfg.dts";
   emap = true;

   mountPoint = 0;
   offset = "0.0445 0 0";
   eyeOffset = "0.56 0.5 -0.8";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = false;

   className = "WeaponImage";
   
   item = BowItem;
   ammo = " ";

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
	minShotTime = 3000;
   
   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Smoke";

	stateName[1]					= "Smoke";
	stateEmitter[1]					= bfgSmokeEmitter;
	stateEmitterTime[1]				= 3;
	stateEmitterNode[1]				= "muzzleNode";
	stateAllowImageChange[1]        = true;
};

function bfgImage::OnEquip(%this,%obj,%slot)
{
	if(getSimTime() - %obj.lastFire[%image] < 3000)
	{	
		%obj.mountImage(bfgCooldwnImage,0);
		%obj.bfgRecharge = (getSimTime() + 3000) - (getsimtime() + (getSimTime() - %obj.lastFire[%image])) | 0;	
		%obj.bfgSchedule = %obj.schedule(%obj.bfgRecharge, mountImage, bfgImage, 0);
	}	
}


function bfgCooldwnImage::OnUnMount(%this,%obj,%slot)
{
	parent::OnUnMount(%this,%obj,%slot);
		cancel(%obj.bfgSchedule);
}
	
function bfgImage::OnFire(%this,%obj,%slot)
{
	%projectile = bfgShellProjectile2;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
		scale = %obj.getScale();
	};
	
	%projectile = bfgShellProjectile;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
		scale = %obj.getScale();
	};

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-10")));	
	serverPlay3D(bfgFireSound,%obj.getPosition());

	%obj.lastFire[%image] = getSimTime();
	%obj.playThread(0, plant);
	%obj.spawnExplosion(bfgRecoilProjectile,"3 3 3");
	MissionCleanup.add(%p);
}

function bfgImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}

function bfgCooldwnImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
